require ( "config" )

function faction_autoplace( placement )
  local optimal_tier = 13 + 2.6 * placement.distance
  local ret = {
    sharpness = 0.4,
    control = placement.team,
    order = "f",
    richness_multiplier = 1,
    richness_base = 0,
    --richness_multiplier_distance_bonus = 1,
    force = placement.team,
    random_probability_penalty = placement.random_probability_penalty,
    peaks =
    {
      {
        influence = 0,
        richness_influence = 100,
        tier_from_start_optimal = optimal_tier,
        tier_from_start_top_property_limit = optimal_tier,
        tier_from_start_max_range = 2 * optimal_tier,
      },
	  {
        influence = -10.0,
        starting_area_weight_optimal = 1,
        starting_area_weight_range = 0,
        starting_area_weight_max_range = 2,
      },	  
	  {
        influence = -10.0,
        noise_layer = "enemy-base",
		starting_area_weight_optimal = 1,
        starting_area_weight_range = 0,
        starting_area_weight_max_range = 2,
      },
      {
        influence = ( 0.223 * placement.spawning_penalty ),
        noise_layer = placement.team,
        noise_octaves_difference = -1.8 * 1.5,
        noise_persistence = 0.5,
      },
      -- increase the size when moving further away
      {
        influence = ( 0.333 * placement.spawning_penalty ),
        noise_layer = placement.team,
        noise_octaves_difference = -1.8 * 1.5,
        noise_persistence = 0.5,
        tier_from_start_optimal = optimal_tier,
        tier_from_start_top_property_limit = optimal_tier,
        tier_from_start_max_range = 2 * optimal_tier,
      },
      {
        influence = 0.001 * placement.distance -- tieberaker
      },
    }
  }
  
   for k, v in pairs ( Robots ) do

		if team ~= v.team then
		
			table.insert( ret.peaks, 
					  {
						influence = -10.0,
						noise_layer = team,
						starting_area_weight_optimal = 1,
						starting_area_weight_range = 0,
						starting_area_weight_max_range = 2,
					  } )
		
		end

  end

  for i, resource in ipairs({"copper-ore", "iron-ore", "coal", "stone","crude-oil"}) do
    -- Prefer bases on resources
    ret.peaks[#ret.peaks + 1] = {
        influence = 0.03,
        noise_layer = resource,
        noise_octaves_difference = -2,
        noise_persistence = 0.3,
        min_influence = 0,
      }
  end

  if placement.is_turret then
    ret.max_probability = placement.max_probability;
  end

  return ret
  
end

function faction_spawner_autoplace( placement )
  return faction_autoplace( placement )
end
